diff --git a/contrib/pg_stat_statements/pg_stat_statements.c b/contrib/pg_stat_statements/pg_stat_statements.c
index 62cccbfa44..184e5c08ea 100644
--- a/contrib/pg_stat_statements/pg_stat_statements.c
+++ b/contrib/pg_stat_statements/pg_stat_statements.c
@@ -2579,7 +2579,18 @@ entry_reset(Oid userid, Oid dbid, uint64 queryid)
 
 	/* All entries are removed? */
 	if (num_entries != num_remove)
+	{
+		if (num_remove)
+		{
+			/* Increment the number of times entries are deallocated */
+			volatile pgssSharedState *s = (volatile pgssSharedState *) pgss;
+
+			SpinLockAcquire(&s->mutex);
+			s->stats.dealloc += 1;
+			SpinLockRelease(&s->mutex);
+		}
 		goto release_lock;
+	}
 
 	/*
 	 * Reset global statistics for pg_stat_statements since all entries are
